<?php
// psauth_controller.php: AppController クラスの具象クラス
/*********************************************************************
*@filename psauth_controller.php
*@description AppController クラスの具象クラス
*@note 
*@histories  rivision	author		date		comment
*			 2.0		yohei		2009/11/04  Mantis 547 PSのMacアドレスを末尾に追加
*            2.0        chenhao     2009/11/09   merge source with so-ten code
*********************************************************************/
//////////////////////////////////////////////////////////////////////
class PsauthsController extends AppController
{   
	var $uses = array("Poll","Psrand",'Configure','Mailserver');
	var $components = array("GenerateFiles");
	var $rdm;
	var $ps_name;
	var $ip;
	var $mac;
	var $usr;
	var $pwd;
	var $ps_id;
	var $modify_flg;
	
	function beforeFilter()
	{
		$this->Configure->write('debug', 0);
	}
	//すべての設定ファイルを生成する


	function genAllSetting()
	{
		$this->GenerateFiles->hook_by_ps(0,
		array('schedule','host','group','mailsrv','popup','appli','pserver','alertsetting','antivirus','process', 'service'));	
	}
	//generate device setting files by ps unit
	function genDeviceByPs()
	{
		$psid = $this->params['pass'];
		if (count($psid) != 0) {
			$this->GenerateFiles->hook_by_ps($psid[0], "device");
			echo "1";
			exit;
		}
		echo "0";
	}
	
	//generate application setting files by ps unit
	function genAppByPs()
	{
		$psid = $this->params['pass'];
		if (count($psid) != 0) {
			$this->GenerateFiles->hook_by_ps($psid[0], "appli");
			echo "1";
			exit;
		}
		echo "0";
	}
	  	
	//yuanxiaojun start 20080610
	function genPsFolders(){

	       $asso = array(
				'Mailserver : mailservers : LEFT' => array('Poll.id = Mailserver.poll_id'),
				'Host : hosts : LEFT' => array('Host.poll_id = Poll.id'),
				'Hstloghead : hstlogheads : LEFT' => array('Host.id = Hstloghead.host_id'),
				'Pollversion : pollversions : LEFT' => array('Poll.id = Pollversion.poll_id'),
	        );
	
                 $where=array("Poll.id<>0  AND (Hstloghead.file_type != 0 OR Hstloghead.file_type is null)");
	        $conditions=array('Poll.id<>0','GROUP BY'=>'Poll.id');
	        $join=$asso;
	        $where=array_merge($where,array('GROUP BY'=>'Poll.id,Poll.poll_name,Pollversion.mversion,Poll.status,Poll.update_time'));
	          
	        list($order,$limit,$page) = $this->Pagination->init($conditions,null,array('ajaxDivUpdate'=>'select','url'=>'/system_all_polls/search', 'modelClass'=>'Poll', 'queryType' => array('function' => 'findByAsso', 'asso' => $join),'sortBy' => $this->Lv->sortBy('Poll.id')));
	          $data = $this->Poll->findByAsso($where, array('distinct(Poll.id) AS Poll__id', 'Poll.poll_name','Pollversion.mversion','MAX(Hstloghead.end_time) AS Hstloghead__poll_time ','Poll.status','Poll.update_time'), $order, $limit, $page, $asso);
	          
	          
	          $spooldir = SPOOL_PATH."\\";
    	          $psArr = $this->params['pass'];
    	          if(!empty($data)){
    	          	foreach ($data as &$value) {
    	          		$psArr[]=$value['Poll']['id'];
    	          	}
    	          }
    	          foreach ($psArr as &$value) {
    	          	
    		         $psdir = $spooldir.$value."\\";
                     
	    	  $rtn = file_exists($psdir);
	    	  if(!$rtn)
	    	  {
		    	if( $this->makePsDir($psdir)) 
		    	{
		    		$this->ps_id = $value;
		    		$rst = $this->Poll->pollfind($value);
		    		$this->mac = $rst[0]["Poll"]["mac_address"];
		    		if( !$this->makeHtaccess($psdir) ) return false;
		    		
		    		if( !$this->writePsConfig() ) return false;
		    		
		    	}
		    	else
		    	{

		    	}
	    	    }
		}
		$this->GenerateFiles->hook_by_ps($psArr, array('pserver','mailsrv'));
//		exit;
		return true;          
	}
	//yuanxiaojun end 20080610	
	
    function genPsAccount()
    {
    	$spooldir = SPOOL_PATH."\\";
    	$psArr = $this->params['pass'];
    	foreach ($psArr as &$value) {
    		
			$psdir = $spooldir.$value."\\";

	    	$rtn = file_exists($psdir);
	    	if(!$rtn)
	    	{
		    	if( $this->makePsDir($psdir)) 
		    	{
		    		$this->ps_id = $value;
		    		$rst = $this->Poll->pollfind($value);
		    		$this->mac = $rst[0]["Poll"]["mac_address"];
		    		if( !$this->makeHtaccess($psdir) ) 
						return false;
		    		
		    		if( !$this->writePsConfig() ) 
						return false;
		    		
		    	}
		    	else
		    	{

		    	}
	    	}
//start yohei 20091104 Mantis 547 PSのMacアドレスを末尾に追加
			else
			{
					$this->ps_id = $value;
					$rst = $this->Poll->pollfind($value);
					$this->mac = $rst[0]["Poll"]["mac_address"];
					if( !$this->makeHtaccess($psdir) ) return false;
						
					if( !$this->writePsConfig() ) return false;
			}
		}
//end yohei 20091104 Mantis 547 PSのMacアドレスを末尾に追加
//		exit;
		return true;
		
    }  
 	
    //C++に向けにインタフェース
	function confirm($pars=null)
	{
		$this->modify_flg =$pars;
		$spooldir = SPOOL_PATH."\\0\\";
		if ($handle = opendir($spooldir)) {
		    while (false != ($filename = readdir($handle))) {
		        if ($filename != "." && $filename != ".." && strlen($filename) == 12) {
		        	 
		           $this->handlePsFile($spooldir.$filename);
		           $this->confirmDB();	 
		                     		
		          @unlink($spooldir.$filename);
		        }
		    }
		    closedir($handle);
		}
		echo "1";
		exit;
    }
    //yuanxiaojun start 20080707
     function confirm2($macaddr=null)
	{
		$ret = "2";//失敗
     	if(!empty($macaddr)){
			$macfile = $macaddr;
			$macaddr = implode('-',str_split($macaddr,2));	//XX-XX-XX-XX-XX-XX
			$poll_id = $this->Poll->macfind($macaddr);
			if($poll_id){
				$existmac = true;//更新
			}else{
				$existmac = false;//新規
			}
			$spooldir = SPOOL_PATH."\\0\\";
			if ($handle = opendir($spooldir)) 
			{
				while (false != ($filename = readdir($handle))) 
				{
					if ($filename != "." && $filename != ".." && strlen($filename) == 12 && $filename == $macfile) 
					{
						$this->handlePsFile($spooldir.$filename);
						//$result = $this->confirmDB2();
						
						$result = true;
						if($existmac){//更新
							$result = $this->updatePS($poll_id);
							if($result == false)
								$ret = "2";//失敗
							else
								$ret = "0";//更新
						}else {//新規
							//同じ名前のPSがないか探す
							$psid = $this->Poll->Namefind($this->Lv->spec_char_dbm($this->ps_name));
							if($psid){//あった
								$ret = "3";//名前が重複
							}else{
								$result = $this->registNewPS();
								if($result == false)
									$ret = "2";//失敗
								else
									$ret = "1";
							}
						}
						
						@unlink($spooldir.$filename);
						break;
		            }
				}
		        closedir($handle);
	        }else{
				$ret = "2";
			}
     	}
		echo $ret;
		exit;
	}
     
      function confirmDB2()
    {	
    	$macaddr = $this->mac;

    	//MACでDBにあるかどうか判別する
    	if($poll_id = $this->Poll->macfind($macaddr) )
    	{	
    		//すでに存在したら、更新する
  			$ps['id'] = $poll_id;
  			$ps['poll_name'] = $this->Lv->spec_char_dbm($this->ps_name);
			$ps['ip_address'] = $this->ip;
			$this->Poll->save($ps);
//start yohei 20091104 Mantis 547 PSのMacアドレスを末尾に追加
			$this->Psrand->deleteAll(array('poll_id = '.$poll_id));
//end yohei 20091104 Mantis 547 PSのMacアドレスを末尾に追加
			$psrand['poll_id'] = $poll_id;
			$psrand['random'] = $this->rdm;
			$this->Psrand->save($psrand);

//start yohei 20091104 Mantis 547 PSのMacアドレスを末尾に追加
			$this->params['pass'] = array($poll_id);
			return $this->genPsAccount();
 //end yohei 20091104 Mantis 547 PSのMacアドレスを末尾に追加
    	}
    	else
    	{
    		//新規登録－承認待ち状態
			$ps['poll_name'] = $this->Lv->spec_char_dbm($this->ps_name);
			$ps['mac_address'] = $macaddr;
			$ps['ip_address'] = $this->ip;
			$ps['status'] = 6;
			$ps['update_time'] = date('Y-m-d H:i:s');
			$this->Poll->save($ps);
   			$ps_id = $this->Poll->getLastInsertID();
//start yohei 20091104 Mantis 547 PSのMacアドレスを末尾に追加
			$this->Psrand->deleteAll(array('poll_id = '.$ps_id));
//end yohei 20091104 Mantis 547 PSのMacアドレスを末尾に追加
						
			$psrand['poll_id'] = $ps_id;
			$psrand['random'] = $this->rdm;
			$this->Psrand->save($psrand);
			return true;
    	}
	}
	
	function updatePS($poll_id)
	{
	   //すでに存在したら、更新する
  		$ps['id'] = $poll_id;
  		$ps['poll_name'] = $this->Lv->spec_char_dbm($this->ps_name);
		$ps['ip_address'] = $this->ip;
		$this->Poll->save($ps);
		$this->Psrand->deleteAll(array('poll_id = '.$poll_id));
		$psrand['poll_id'] = $poll_id;
		$psrand['random'] = $this->rdm;
		$this->Psrand->save($psrand);

		$this->params['pass'] = array($poll_id);
		return $this->genPsAccount();
	}
	
	function registNewPS()
    {	
	//新規登録
		$ps['poll_name'] = $this->Lv->spec_char_dbm($this->ps_name);
		$ps['mac_address'] = $this->mac;
		$ps['ip_address'] = $this->ip;
		$ps['status'] = 7;
		$ps['update_time'] = date('Y-m-d H:i:s');
		$this->Poll->save($ps);
   		$ps_id = $this->Poll->getLastInsertID();

		$this->Psrand->deleteAll(array('poll_id = '.$ps_id));
		$psrand['poll_id'] = $ps_id;
		$psrand['random'] = $this->rdm;
		$this->Psrand->save($psrand);

		$this->params['pass'] = array($ps_id);
				//=========================				
		$datamail = $this->Mailserver->findAll('Mailserver.poll_id ='.$ps_id,null, null,null,null);
		if(empty($datamail[0]['Mailserver']['id']))
		{
			$def = $this->Mailserver->findAll(array("Mailserver.default_server" => 0),null, null,null,null);
			if(!empty($def))
			{
				$mailservers['poll_id']=$ps_id;
				$mailservers['smtp']=$def[0]['Mailserver']['smtp'];
				$mailservers['smtp_port']=$def[0]['Mailserver']['smtp_port'];
				$mailservers['mail_address']=$def[0]['Mailserver']['mail_address'];
				$mailservers['pop']=$def[0]['Mailserver']['pop'];
				$mailservers['pop_port']=$def[0]['Mailserver']['pop_port'];
				$mailservers['pop_user']=$def[0]['Mailserver']['pop_user'];
				$mailservers['pop_password']=$def[0]['Mailserver']['pop_password'];
				$mailservers['default_server']=0;
				$this->Mailserver->save($mailservers);
			}
		}
	
		if($this->genPsAccount())
			return true;
		else{
			$this->Psrand->deleteAll(array('poll_id = '.$ps_id));
			$this->Mailserver->deleteAll(array('poll_id = '.$ps_id));
			$this->Poll->deleteAll(array('id = '.$ps_id));
			return false;
		}
    }
    
    function handlePsFile($filename)
    {
    	$handle = fopen($filename, "rb");
		$dword_cnt = 0;
		$str_cnt = 0;
		$str_len = 0;
		
		$file_size = filesize($filename);
		
		$rdm_value = $this->dec_header($handle);
		$dword_cnt += 1;	
		$this->rdm = $rdm_value;
				
		$bindata = fread($handle,$file_size);
    	$ps_info = $this->GenerateFiles->dec_cstring($bindata);	
    	
    	fclose($handle);
    	
    	$this->ps_name = $ps_info[0];
    	$this->ip = $ps_info[1];
    	$this->mac = $ps_info[2];
		$this->mac = implode('-',str_split($this->mac,2));
    }

   
	function dec_header($handle)
	{
		$bindata = fread($handle,4);
		$data = unpack("V", $bindata);
		return $data[1];
	}

	function enc_psinfo($content)
	{
//		var_dump($content);
		for ($i = 0; $i < strlen($content); $i++) 
    	{
    		$content[$i] =  chr(ord($content[$i])+$this->rdm);
//    		var_dump($content[$i],ord($content[$i]),$this->rdm);print "<br>";
    	}
    	return $content;
	}
	
//	function enc_psinfo_int($content)
//	{
//		return chr($content + $this->rdm);
//	}

	function makePsDir($psdir)
	{
		mkdir($psdir);
		mkdir($psdir."\\conf");
		mkdir($psdir."\\data");
		mkdir($psdir."\\alert");
		mkdir($psdir."\\upgrade");
		mkdir($psdir."\\xml");
		
		return true;
    }
    function writePsConfig()
    {
		$pssharedir = SPOOL_PATH."\\0\\";
		$psfile= $pssharedir."PS-".str_replace('-','',$this->mac);
		$rtn = file_exists($psfile);
    	if($rtn)
    	{
    		if(!unlink($psfile))
    		{
    			return false;
    		}
    	}

    	$rs = $this->Psrand->find("poll_id=".$this->ps_id);
    	if (!$rs) {
    		return false;
    	}
    	$this->rdm = $rs["Psrand"]["random"];
    	
//    	$rdm_value = $this->enc_psinfo($this->rdm);
    	
//    	$rdm_value = $this->GenerateFiles->enc_dword($this->rdm);
//    	$rdm_value = $this->GenerateFiles->enc_dword($rdm_value);
    	
    	$ps_id = $this->enc_psinfo($this->ps_id);
		$ps_id = $this->GenerateFiles->enc_cstring($ps_id, false);
		
		$usr = $this->enc_psinfo($this->usr);
		$usr = $this->GenerateFiles->enc_cstring($usr, false);

		$pwd = $this->enc_psinfo($this->pwd);
		$pwd = $this->GenerateFiles->enc_cstring($pwd, false);
		
// yohei start modify 20091104 for Mantis 547 PSのMacアドレスを末尾に追加
//		$content = $ps_id.$usr.$pwd;
		$retmac = str_replace('-','',$this->mac);
		$retmac = $this->enc_psinfo($retmac);
		$retmac = $this->GenerateFiles->enc_cstring($retmac,false);
		$content = $ps_id.$usr.$pwd.$retmac ;
// yohei end modify 20091104 for Mantis 547 PSのMacアドレスを末尾に追加

//		var_dump($content);
    	$handle = fopen($psfile, "wb");
    	if(!$handle)
    	{
    		return false;
    	}

//    	if (!fwrite($handle, $rdm_value)) {
//    	    return false;
//	    }
	    
    	if (!fwrite($handle, $content)) {
    	    return false;
	    }

	    fclose($handle);
		return true;
	}
    function makeHtaccess($psdir)
    {
    	$this->usr = $this->genRandomString(50);
    	$this->pwd = $this->genRandomString(50);
		
		$rootpath = SPOOL_PATH."\\";
		
		$cmdpath = APP."..\\tools\\";
		
		$temp = tempnam("/tmp", "CONTROL");
		if (file_exists($rootpath."control.passwd")) {
			copy($rootpath."control.passwd", $temp);
		}

		$toexec = sprintf("\"%shtpasswd.exe\" -db %s %s %s",$cmdpath, $temp, $this->usr,$this->pwd);
		exec( $toexec, $result, $retcode );

		copy($temp, $rootpath."control.passwd");
		unlink($temp);

/*
		$temp = tempnam("/tmp", "HTACCESS");
		$fp = fopen($temp, "w");
		fwrite($fp, sprintf("%s\n%s\n%s", $this->usr, $psdir.".htaccess", str_replace("\\", "/", $rootpath."control.passwd")));
		fclose($fp);
		
		$toexec = sprintf("\"%sAddLimitUser.exe\" %s", $cmdpath, $temp);
		//$toexec = sprintf("\"%swhoami.exe\"",$cmdpath,$this->usr,$psdir.".htaccess",$rootpath."control.passwd");
		$result = exec( $toexec );
		//copy($temp, $psdir.".htaccess");
		unlink($temp);//var_dump($psdir.".htaccess");
*/
		if($retcode == 0)
		return true;
		else 
		return false;
    }
    
    function confirmDB()
    {	
    	$mac = implode('-',str_split($this->mac,2));
    	
    	//MACでDBにあるかどうか判別する
    	if($poll_id = $this->Poll->macfind($mac) )
    	{	
    		//すでに存在したら、更新する
  			$ps['id'] = $poll_id;
  			$ps['poll_name'] = $this->ps_name;
			$ps['ip_address'] = $this->ip;
			$this->Poll->save($ps);

			$psrand['poll_id'] = $poll_id;
			$psrand['random'] = $this->rdm;
			$this->Psrand->save($psrand);

    	}
    	elseif($this->modify_flg == null)
    	{
    		//PS名など変更ではない


    		//新規登録－承認待ち状態


			$ps['poll_name'] = $this->ps_name;
			$ps['mac_address'] = $mac;
			$ps['ip_address'] = $this->ip;
			$ps['status'] = 6;
			$ps['update_time'] = date('Y-m-d H:i:s');
			$this->Poll->save($ps);
   			$ps_id = $this->Poll->getLastInsertID();
						
			$psrand['poll_id'] = $ps_id;
			$psrand['random'] = $this->rdm;
			$this->Psrand->save($psrand);

    	}
    	else
    	{
    		//PS名変更の時、何もしない
    	}
    	
    }
    
    function genRandomString($len)
	{
	    $chars = array(
	        "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", 
	        "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", 
	        "w", "x", "y", "z", "A", "B", "C", "D", "E", "F", "G", 
	        "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", 
	        "S", "T", "U", "V", "W", "X", "Y", "Z", "0", "1", "2", 
	        "3", "4", "5", "6", "7", "8", "9"
	    );
	    $charsLen = count($chars) - 1;
	 
	    shuffle($chars);
	    
	    $output = "";
	    for ($i=0; $i<$len; $i++)
	    {
	        $output .= $chars[mt_rand(0, $charsLen)];
	    }
	 
	    return $output;
 
	}

}
?>