<?php
class SystemAllNetscanconfController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check', 'GenerateFiles');
	var $uses=array('Netscanconf','Configure','Validation','Mailaddress','Host','Poll','Validation','Version','Someauth','Authority','Somemod','Module');
	var $layout='system';
	//    var $pageTitle = 'LVシステム管理/全体設定/ライセンス';

	function beforeFilter()
	{
		// $this->Configure->write('debug',0);
		parent::beforeFilter();
		
		$this->pageTitle =__('title',$return = true);
	}
	
	function index()
	{

		
		$search= $this->requestAction('/system_all_netscanconf/mail_set/',array('return'));
		$this->set('search',$search);
		//$this->render('index');
	}
	
	function addline($count){
		$this->layout='ajax';
		
		$this->set('myid', $count);
	}
	
	function mail_set(){
		$this->layout='ajax';
		$group_id=$this->_getUserGroup();
		
		$polllistnone = $this->Poll->generateList(null, null, null, '{n}.Poll.id', '{n}.Poll.poll_name', null);
		unset($polllistnone[0]);//var_dump($polllistnone);
		ksort($polllistnone);
		$this->set('polllistnone',$polllistnone);
		
		$confs=$this->Netscanconf->findAll(null,null,"id");

		$this->set('count',count($confs));
		$this->set('confs',$confs);
	}
	
	function set_str_encoding($name)
    {
        $result= mb_convert_encoding($name,__('CharacterSet',$retrun=true),"UTF-8"); 
        return $result;
    } 
	
	//設定更新
	function mail_save(){
		$this->layout='ajax';
		$group_id=$this->_getUserGroup();
		$err= array();

//var_dump($this->data);

		$adddatas = array();
		foreach($this->data as $i => $conf){
			$id = $conf['Netscanconf']['id'];
			$ip_from = trim($conf['Netscanconf']['ip_from']);
			$ip_to = trim($conf['Netscanconf']['ip_to']);

			$all = empty($conf['Netscanconf']['all']) ? 0 : 127;
			$mon = empty($conf['Netscanconf']['mon']) ? 0 : 1;
			$tue = empty($conf['Netscanconf']['tue']) ? 0 : 2;
			$wed = empty($conf['Netscanconf']['wed']) ? 0 : 4;
			$thu = empty($conf['Netscanconf']['thu']) ? 0 : 8;
			$fri = empty($conf['Netscanconf']['fri']) ? 0 : 16;
			$sat = empty($conf['Netscanconf']['sat']) ? 0 : 32;
			$sun = empty($conf['Netscanconf']['sun']) ? 0 : 64;
			$week_day = $mon+$tue+$wed+$thu+$fri+$sat+$sun;
			if($week_day < $all)
				$week_day = $all;
			
			$start_hour = $conf['Netscanconf']['start_hour'];
			$start_min = $conf['Netscanconf']['start_min'];
			$span_time = $conf['Netscanconf']['span_time'];
			
			//値のチェック
			$valid = true;
			if($this->Validation->blank($ip_from)){
				$err['ip_from']=__('blank_error',$return = true);
				$valid = false;
			}else if(!$this->Validation->ip($ip_from)){
				$err['ip_from']=__('format_error',$return = true);
				$valid = false;
			}
			
			if($this->Validation->blank($ip_to)){
				$err['ip_to']=__('blank_error',$return = true);
				$valid = false;
			}else if(!$this->Validation->ip($ip_to)){
				$err['ip_to']=__('format_error',$return = true);
				$valid = false;
			}
			
			//ipの範囲チェック
			$ipf = explode(".", $ip_from);
			$ipt = explode(".", $ip_to);
			if($valid){
				if($ipf[0] != $ipt[0] || $ipf[1] != $ipt[1] || $ipf[2] != $ipt[2] || $ipf[3] >= $ipt[3] )
				{
					$err['ip_range']=__('range_error',$return = true);
					//echo $ipf[0].$ipf[1].$ipf[2].$ipf[3];
					//echo $ipt[0].$ipt[1].$ipt[2].$ipt[3];
					$valid = false;
				}
			}
			
			//曜日
			if($week_day ==0)
			{
				$err['scanweek']=__('select_error',$return = true);
			}
			
			if($valid){
				$adddatas[] = Array(
					'id' => $id,
					'group_id'=> 1,
					'ip_from'=> $ip_from,
					'ip_to'=> $ip_to,
					'weekday'=> $week_day,
					'start_time'=> $start_hour.":".$start_min,
					'span_time'=> $span_time,
				);
			}
		}

		if(!empty($err))
		{
			$this->set('err',$err);
		}else{
			$delete_mail = "delete from netscanconfs where group_id = 1";
			$this->Netscanconf->query($delete_mail);
//var_dump($adddatas);
			//追加
			foreach($adddatas as $add){
				$this->Netscanconf->save($add);
			}
			$this->GenerateFiles->hook_by_ps(0, array('netscanschedule'), 1);
		}

	}
}
?>